-- Stillman Lecture 4, AWS 2006, Tucson, March 11-15.
---------------------------------------
-- Improving presentation of a sheaf --
---------------------------------------

omega = (I) -> (
     S := ring I;
     R := S/I;
     omegaX := prune homology(vars S ** R,jacobian gens I ** R);
     coker lift(presentation omegaX,S)
     )

S = QQ[a,b,c,d,e]
I = ideal(a^5+b^5+c^5+d^5+e^5)
omegaX = omega I

om2 = omegaX ** omegaX;
betti om2
om2sat = coker gens saturate(image presentation om2);
betti om2sat
res om2
res om2sat
betti oo
om2depth2 = HH^0((sheaf om2)(>=0));
betti om2depth2
betti om2
res om2depth2
betti oo

E3 = Ext^3(om2,S^{-5})
E3b = Ext^3(om2sat,S^{-5})
E3c = Ext^3(om2depth2,S^{-5})
hilbertFunction({0},E3)
hilbertFunction({0},E3b)
hilbertFunction({0},E3c)

--------------------------
-- Fermat cubic surface --
--------------------------
intersection = (M,N) -> euler ring M - euler M - euler N + euler(M**N)
kk = QQ
S = kk[a..d]
I = ideal(a^3+b^3+c^3+d^3)
R = S/I
L1 = ideal(a+b,c+d)
L2 = ideal(a+c,b+d)
OOL1 = Hom(L1,R)
OOL2 = Hom(L2,R)
intersection(OOL1,OOL1)
intersection(module L1, module L1)
intersection(OOL1,OOL2)
intersection(OOL2,OOL2)
genus L1
genus L2

basis(0,OOL1)
f  = homomorphism oo
source f
target f
ideal image f
oo == L1

OOL1 = prune OOL1
basis(0,oo)

OOL1' = Hom(OOL1,R)
OOL1'' = Hom(OOL1',R)
basis(0,oo)
f = homomorphism oo
source f == OOL1'
target f
ideal image f
oo == L1

use S
decompose(I + ideal(a+b+c+d))
use R
L3 = ideal(a+d,b+c)
OOL3 = Hom(L3,R)

M = OOL1 ** OOL2 ** OOL3
coker gens saturate(image presentation M)
MS = coker lift(presentation oo,S)
res MS
HH^0((sheaf MS)(>=0))
sheaf oo

-----------------------
-- A mystery surface --
-----------------------
kk = ZZ/32003
S = kk[a..e]

I = ideal(490*a^3+12221*a^2*b+1663*a*b^2-14146*b^3-6390*a^2*c-8829*a*b*c
           +6322*b^2*c-9839*a*c^2-7186*b*c^2-4124*c^3-6141*a^2*d+15804*a*b*d
	   -10963*b^2*d-14244*a*c*d+3292*b*c*d+12528*c^2*d+1470*a*d^2
	   +9748*b*d^2-4690*c*d^2-11431*d^3-10463*a^2*e+965*a*b*e
	   +15018*b^2*e+3510*a*c*e-13207*b*c*e-12332*c^2*e+5496*a*d*e
	   -1110*b*d*e-14202*c*d*e+4737*d^2*e+11286*a*e^2+3759*b*e^2
	   -12124*c*e^2-8044*d*e^2-8400*e^3,
     -4212*a^3-6354*a^2*b+8359*a*b^2-15620*b^3-7605*a^2*c+14070*a*b*c+1533*b^2*c-6538*a*c^2+1929*b*c^2+6483*c^3+2503*a^2*d-13769*a*b*d-10716*b^2*d+15442*a*c*d-10241*b*c*d+4046*c^2*d-7595*a*d^2-4553*b*d^2-5535*c*d^2-12507*d^3-8300*a^2*e+9255*a*b*e-166*b^2*e-3948*a*c*e-887*b*c*e+12166*c^2*e-12019*a*d*e-4986*b*d*e-9965*c*d*e-2795*d^2*e-11300*a*e^2-9200*b*e^2+2201*c*e^2+771*d*e^2-10878*e^3,
     -13422*a^3-13098*a^2*b+165*a*b^2-15751*b^3-9062*a^2*c+3931*a*b*c+10465*b^2*c+3947*a*c^2+15856*b*c^2-13765*c^3+12661*a^2*d-759*a*b*d+2367*b^2*d-5578*a*c*d-10985*b*c*d+987*c^2*d-9772*a*d^2-1366*b*d^2+2179*c*d^2-13964*d^3-11350*a^2*e-1598*a*b*e+2754*b^2*e-9928*a*c*e+13439*b*c*e+15037*c^2*e-9065*a*d*e+12521*b*d*e+9348*c*d*e-10519*d^2*e-13803*a*e^2+6223*b*e^2-6660*c*e^2+9736*d*e^2+5263*e^3,
     14635*a^3+2059*a^2*b-5482*a*b^2-14747*b^3+1035*a^2*c-4988*a*b*c+11895*b^2*c+13195*a*c^2+7097*b*c^2-8995*c^3+1144*a^2*d-11329*a*b*d-14481*b^2*d-4991*a*c*d+14404*b*c*d+10242*c^2*d-6921*a*d^2-6661*b*d^2-15585*c*d^2+9999*d^3+4902*a^2*e-12029*a*b*e-681*b^2*e-2020*a*c*e+14081*b*c*e+15876*c^2*e+7994*a*d*e+7138*b*d*e-3671*c*d*e+11424*d^2*e+380*a*e^2-11858*b*e^2+9754*c*e^2+13383*d*e^2+6735*e^3);
codim I
degree I
R = S/I
K = Ext^2(S^1/I,S^{-5})
HH^0(sheaf K)
intersection(K,K) == -1
intersection(K,(S^1/I) ** (S^{1})) --  H.K = -2

K2 = K ** K;
res K2
HH^0(sheaf K2)
HH^1(sheaf R)
-- Castelnuovo: X = V(I) is rational

-- Consider H+2K, H+K.  Compute their H^0.
HH^0((sheaf K2)(1)) -- | H + 2K | is empty
K = K ** R;
K = K ** R^{1}
HH^0(sheaf K) 
-- So 3 sections, giving map to P^2.

K' = Hom(K,R)
K'' = Hom(K',R)
F = basis(0,K'')
F_{0}
C = ideal image homomorphism(F_{0})
OOC = Hom(C,R)
intersection(OOC,OOC)
-- we have found a rational
CS = trim(ideal lift(gens C,S) + I)
betti CS
decompose CS
-- So CS is a degree 4 rational curve on X
-- with C^2 = 1
HH^0(sheaf OOC)

-- above example comes from
-- I = minors(3,random(S^3, S^{-1,-1,-1,-1}))
